#include <gl/gl.h>
#include <gl/device.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "forms.h"
#include "gv_forms.h"
#include "types.h"
#include "id.h"

#define RGB_MODE 0
#define HSI_MODE 1

extern screenT screen;
extern long overlay_win;
extern long id_win;
extern char two_dump[XSIZE][YSIZE][3];

static char id_mode_r[17]; 
static char id_mode_g[17]; 
static char id_mode_b[17]; 
static long mode_r[256]; 
static long mode_g[256]; 
static long mode_b[256]; 
static char single_mode_r; 
static char single_mode_g; 
static char single_mode_b; 

static char current_colour[17]; 
static long current_col; 

static char id_num_grains = 0; 

static char id_pixel[XSIZE][YSIZE];
static long id_current_image_flag = 1;
static char id_flag = 0;
static char finished_id_flag = 0;
static long id_hist_win = -1;
static char id_hist_flag = 0;
static char red_col, green_col, blue_col;

char *min_name_change[14];

/****************************************************************/
/*Assigns mineral types.					*/
/****************************************************************/
void id_but_proc(FL_OBJECT *n, long m)
{
if(id_hist_flag == 1)
{
	id_stop_grain_hist_proc(NULL, 0);
}

if(id_flag == 0)
{
	init_id();
	id_flag = 1;
}

current_col = m;
switch(m)
{
	case 1:
		red_col = 255;
		green_col = 255;
		blue_col = 255;
		break;
	case 2:
		red_col = 255;
		green_col = 0;
		blue_col = 0;
		break;
	case 3:
		red_col = 0;
		green_col = 255;
		blue_col = 0;
		break;
	case 4:
		red_col = 0;
		green_col = 0;
		blue_col = 100;
		break;
	case 5:
		red_col = 255;
		green_col = 255;
		blue_col = 0;
		break;
	case 6:
		red_col = 255;
		green_col = 0;
		blue_col = 255;
		break;
	case 7:
		red_col = 0;
		green_col = 255;
		blue_col = 255;
		break;
	case 8:
		red_col = 170;
		green_col = 110;
		blue_col = 110;
		break;
	case 9:
		red_col = 110;
		green_col = 170;
		blue_col = 110;
		break;
	case 10:
		red_col = 110;
		green_col = 110;
		blue_col = 170;
		break;
	case 11:
		red_col = 120;
		green_col = 120;
		blue_col = 60;
		break;
	case 12:
		red_col = 120;
		green_col = 60;
		blue_col = 120;
		break;
	case 13:
		red_col = 60;
		green_col = 120;
		blue_col = 120;
		break;
	case 14:
		red_col = 160;
		green_col = 160;
		blue_col = 160;
		break;
	case 15:
		red_col = 0;
		green_col = 0;
		blue_col = 0;
		break;
	case 16:
		red_col = 70;
		green_col = 70;
		blue_col = 70;
		break;
	default:
		break;
}
}

/****************************************************************/
/*Initializes mouse for use in identifying species.		*/
/****************************************************************/
void init_id()
{
id_mode_init();
id_array_init();
id_array_init2();
fl_set_event_call_back(id_callback);
}

/****************************************************************/
/*Dummy routine to take care of mouse events when click is not	*/
/*desired to give input.					*/
/****************************************************************/
void id_dummy_callback(short dev, short val)
{
}

/****************************************************************/
/*Procedure is called when left mouse button is pressed inside 	*/
/*the overlay window.						*/
/****************************************************************/
void id_callback(short dev, short val)
{
short x, y, xpos, ypos;
int best_r, best_g, best_b;
short i;
long xx, yy;

winset(overlay_win);
getorigin(&xx, &yy);
while(getbutton(LEFTMOUSE))
{
	xpos = (short)(getvaluator(MOUSEX) - xx);
	ypos = YSIZE - (short)(getvaluator(MOUSEY) - yy);
}

if( ((xpos < XSIZE) && (xpos >= 0))
&&((ypos < YSIZE) && (ypos >= 0)) )
{
	winset(id_win);

	id_num_grains++;
	current_colour[id_num_grains] = current_col;
	id_mode_r[id_num_grains] = 0;
	id_mode_g[id_num_grains] = 0;
	id_mode_b[id_num_grains] = 0;
		
	id_fill_grain(xpos, ypos, 155, 255);
	dump_image(two_dump);
		
	best_r = 0;
	best_g = 0;
	best_b = 0;
	for(i = 0; i < 256; i++)
	{
		if(mode_r[i] > best_r)
		{
			id_mode_r[id_num_grains] = i;
			best_r = mode_r[i];
		}
		mode_r[i] = 0;
			
		if(mode_g[i] > best_g)
		{
			id_mode_g[id_num_grains] = i;
			best_g = mode_g[i];
		}
		mode_g[i] = 0;
			
		if(mode_b[i] > best_b)
		{
			id_mode_b[id_num_grains] = i;
			best_b = mode_b[i];
		}
		mode_b[i] = 0;
	}	
	winset(overlay_win);
	dump_image(two_dump);
	
	fprintf(stderr,"\n\nblue = %d", id_mode_b[id_num_grains]);	
	fprintf(stderr,"\nred = %d", id_mode_r[id_num_grains]);	
	fprintf(stderr,"\ngreen = %d", id_mode_g[id_num_grains]);	
	fprintf(stderr,"\nall = %d",(id_mode_r[id_num_grains]+id_mode_g[id_num_grains]+id_mode_b[id_num_grains])/3);	
}
}

/****************************************************************/
/*Fills the grain selected by a mouse click with the current 	*/
/*colour selected in the selection boxes.			*/
/****************************************************************/
void id_fill_grain(short x, short y, char new, char boundary)
{
if( (id_pixel[x][y] != boundary)
&&(id_pixel[x][y] != new) )
{
	mode_r[valat(two_dump, x, y, R)]++;
	mode_g[valat(two_dump, x, y, G)]++;
	mode_b[valat(two_dump, x, y, B)]++;
	screen.types[x][y].mineral_type = current_col;
	assval(two_dump, x, y, R, red_col);
	assval(two_dump, x, y, G, green_col);
	assval(two_dump, x, y, B, blue_col);
	id_pixel[x][y] = new;
	id_fill_grain(x - 1, y, new, boundary);
	id_fill_grain(x + 1, y, new, boundary);
	id_fill_grain(x, y - 1, new, boundary);
	id_fill_grain(x, y + 1, new, boundary);
}
}

/****************************************************************/
/*Performs statistics on grains to identify them.		*/
/****************************************************************/
void id_grains_proc(FL_OBJECT *n, long m)
{
short x, y, x1, y1;
short score_mark, i;
short best_r, best_g, best_b;
short best_mode_r, best_mode_g, best_mode_b;
unsigned long diff_mode_r, diff_mode_g, diff_mode_b;
unsigned long sum_diff, best_sum;

winset(id_win);
for(x = 0; x < XSIZE; x++)
{
	for(y = 0; y < YSIZE; y++)
	{
		if( (screen.scr[x][y].complete_edge == 0)
		&&(screen.types[x][y].mineral_type == 16)
		&&(id_pixel[x][y] == 0) )
		{
			id_fill_grain(x, y, 155, 255);

			best_r = 0;
			best_g = 0;
			best_b = 0;
			for(i = 0; i < 256; i++)
			{
				if(mode_r[i] > best_r)
				{
					single_mode_r = i;
					best_r = mode_r[i];
				}
				mode_r[i] = 0;
				
				if(mode_g[i] > best_g)
				{
					single_mode_g = i;
					best_g = mode_g[i];
				}
				mode_g[i] = 0;
				
				if(mode_b[i] > best_b)
				{
					single_mode_b = i;
					best_b = mode_b[i];
				}
				mode_b[i] = 0;
			}
		
			best_sum = 55000000;
			for(i = 1; i <= id_num_grains; i++)
			{
				diff_mode_r = (abs(id_mode_r[i] - single_mode_r)) 
					    * (abs(id_mode_r[i] - single_mode_r))
					    * (abs(id_mode_r[i] - single_mode_r));
				
				diff_mode_g = (abs(id_mode_g[i] - single_mode_g)) 
					    * (abs(id_mode_g[i] - single_mode_g))
					    * (abs(id_mode_g[i] - single_mode_g));
				
				diff_mode_b = (abs(id_mode_b[i] - single_mode_b)) 
					    * (abs(id_mode_b[i] - single_mode_b))
					    * (abs(id_mode_b[i] - single_mode_b));

				sum_diff = diff_mode_r + diff_mode_g + diff_mode_b;
			
				if(sum_diff < best_sum)
				{
					best_sum = sum_diff;
					score_mark = i;
				}
			}
			id_but_proc(NULL, current_colour[score_mark]);
			id_fill_grain(x, y, 157, 255);
			dump_image(two_dump);

			for(i = 0; i < 256; i++)
			{
				mode_r[i] = 0;
				mode_g[i] = 0;
				mode_b[i] = 0;
			}
		}
	}
}

for(x = 0; x < XSIZE; x++)
{
	for(y = 0; y < YSIZE; y++)
	{
		id_pixel[x][y] = screen.scr[x][y].complete_edge;
	}
}
winset(overlay_win);
finished_id_flag = 1;
}

/****************************************************************/
/*Provides a manual over-ride for grains that were not properly */
/*identified.							*/
/****************************************************************/
void id_over_ride_proc(FL_OBJECT *n, long m)
{

if(id_hist_flag == 1)
{
	id_stop_grain_hist_proc(NULL, 0);
}

if(finished_id_flag == 0)
{
	fl_show_message("","OVER-RIDE ONLY AVAILABLE AFTER GRAINS HAVE BEEN IDENTIFIED.","");
}

else
{
	fl_set_event_call_back(id_over_ride_callback);
}
}

/****************************************************************/
/*Provides a manual over-ride for grains that were not properly */
/*identified.							*/
/****************************************************************/
void id_over_ride_callback(short dev, short val)
{
short x, y, xpos, ypos;
short i;
long xx, yy;

winset(overlay_win);
getorigin(&xx, &yy);
while(getbutton(LEFTMOUSE))
{
	xpos = (short)(getvaluator(MOUSEX) - xx);
	ypos = YSIZE - (short)(getvaluator(MOUSEY) - yy);
}

if( ((xpos < XSIZE) && (xpos >= 0))
&&((ypos < YSIZE) && (ypos >= 0)) )
{
	winset(id_win);
	id_fill_grain(xpos, ypos, 155, 255);
	dump_image(two_dump);
	winset(overlay_win);

	for(i = 0; i < 256; i++)
	{
		mode_r[i] = 0;
		mode_g[i] = 0;
		mode_b[i] = 0;
	}
	
	for(x = 0; x < XSIZE; x++)
	{
		for(y = 0; y < YSIZE; y++)
		{
			id_pixel[x][y] = screen.scr[x][y].complete_edge;
		}
	}
}
}

/****************************************************************/
/*Outputs a histogram of a selected grain.			*/
/****************************************************************/
void id_start_grain_hist_proc(FL_OBJECT *n, long m)
{
if(id_hist_flag == 0)
{
	id_hist_flag = 1;

	if(id_flag == 1)
	{
		id_flag = 0;
	}
	fl_set_event_call_back(id_hist_callback);
	
	prefsize(256, 700);
	id_hist_win = winopen("Grain Histogram");
	gconfig();
	
	winset(id_hist_win);
	color(WHITE);
	clear();
	winset(overlay_win);

	id_mode_init();
	id_array_init();
	id_array_init2();
}
}

/****************************************************************/
/*Call back routine for grain histogram.			*/
/****************************************************************/
void id_hist_callback(short dev, short val)
{
short x, y, xpos, ypos, i;
long xx, yy;
long vector[2];

winset(overlay_win);
getorigin(&xx, &yy);
while(getbutton(LEFTMOUSE))
{
	xpos = (short)(getvaluator(MOUSEX) - xx);
	ypos = YSIZE - (short)(getvaluator(MOUSEY) - yy);
}

if( ((xpos < XSIZE) && (xpos >= 0))
&&((ypos < YSIZE) && (ypos >= 0)) )
{
	winset(id_hist_win);
	color(WHITE);
	clear();
	id_hist_fill(xpos, ypos, 100, 255);
	
	bgnline();
	color(RED);
	for(i = 0; i < 256; i++)
	{
		vector[0] = i;
		if(mode_r[i] > 700)
			mode_r[i] = 700;
		vector[1] = mode_r[i];
		v2i(vector);
		mode_r[i] = 0;
	}
	endline();
		
	bgnline();
	color(GREEN);
	for(i = 0; i < 256; i++)
	{
		vector[0] = i;
		if(mode_g[i] > 700)
			mode_g[i] = 700;
		vector[1] = mode_g[i];
		v2i(vector);
		mode_g[i] = 0;
	}
	endline();
		
	bgnline();
	color(BLUE);
	for(i = 0; i < 256; i++)
	{
		vector[0] = i;
		if(mode_b[i] > 700)
			mode_b[i] = 700;
		vector[1] = mode_b[i];
		v2i(vector);
		mode_b[i] = 0;
	}
	endline();
	gflush();
	
	for(x = 0; x < XSIZE; x++)
	{
		for(y = 0; y < YSIZE; y++)
		{
			id_pixel[x][y] = screen.scr[x][y].complete_edge;
		}
	}
}
}

/****************************************************************/
/*Gets the histogram of the selected grain.			*/
/****************************************************************/
void id_hist_fill(short x, short y, char new, char boundary)
{
char check;

check = id_pixel[x][y];
if( (check != boundary)
&&(check != new) )
{
	mode_r[(short)valat(two_dump, x, y, R)]++;
	mode_g[(short)valat(two_dump, x, y, G)]++;
	mode_b[(short)valat(two_dump, x, y, B)]++;
	id_pixel[x][y] = new;
	id_hist_fill(x - 1, y, new, boundary);
	id_hist_fill(x + 1, y, new, boundary);
	id_hist_fill(x, y - 1, new, boundary);
	id_hist_fill(x, y + 1, new, boundary);
}
}

/****************************************************************/
/*Outputs a histogram of a selected grain.			*/
/****************************************************************/
void id_stop_grain_hist_proc(FL_OBJECT *n, long m)
{
if(id_hist_flag == 1)
{
	id_hist_flag = 0;
	winclose(id_hist_win);
	id_hist_win = -1;
	winset(overlay_win);
	fl_set_event_call_back(id_dummy_callback);
}
}

/****************************************************************/
/*Puts the values of the chosen image into array two_dump and 	*/
/*overlays the current edges on top.				*/
/****************************************************************/
void put_overlay_pixels_proc(FL_OBJECT *n, long m)
{
short x, y;

if(id_current_image_flag != m)
{
	id_current_image_flag = m;
	put_overlay_pixels(m);
	
	winset(id_win);
	dump_image(two_dump);

	winset(overlay_win);
	dump_image(two_dump);

	id_array_init();
	/*
	id_array_init2();
	*/
	id_mode_init();

	if(finished_id_flag == 1)
	{	
		overlay_finished();
		dump_image(two_dump);
		winset(overlay_win);
		dump_image(two_dump);
	}
}
}

/****************************************************************/
/*Overalays identified grains.					*/
/****************************************************************/
void overlay_finished()
{
short x, y;

winset(id_win);
for(x = 0; x < XSIZE; x++)
{
	for(y = 0; y < YSIZE; y++)
	{
		if((screen.scr[x][y].complete_edge == 0)
		/*
		&&(screen.types[x][y].mineral_type != 0) 
		*/
		&&(screen.types[x][y].mineral_type != 16) )
		{
			id_but_proc(NULL, screen.types[x][y].mineral_type);
			assval(two_dump, x, y, R, red_col);
			assval(two_dump, x, y, G, green_col);
			assval(two_dump, x, y, B, blue_col);
		}
	}
}
}

/****************************************************************/
/*Puts the values of the chosen image into array two_dump and 	*/
/*overlays the current edges on top.				*/
/****************************************************************/
void put_overlay_pixels(long m)
{
short x, y;

if(m == 0)
{
	for(x = 0; x < XSIZE; x++)
	{
		for(y = 0; y < YSIZE; y++)
		{
			if(screen.scr[x][y].complete_edge == 0)
			{
				assval(two_dump, x, y, R, screen.scr[x][y].max[SR]);
				assval(two_dump, x, y, G, screen.scr[x][y].max[SG]);
				assval(two_dump, x, y, B, screen.scr[x][y].max[SB]);
			}
	
			else
			{
				assval(two_dump, x, y, R, 0);
				assval(two_dump, x, y, G, 0);
				assval(two_dump, x, y, B, screen.scr[x][y].complete_edge);
			}
		}
	}
}

else if(m == 1)
{
	for(x = 0; x < XSIZE; x++)
	{
		for(y = 0; y < YSIZE; y++)
		{
			if(screen.scr[x][y].complete_edge == 0)
			{
				assval(two_dump, x, y, R, screen.scr[x][y].min[SR]);
				assval(two_dump, x, y, G, screen.scr[x][y].min[SG]);
				assval(two_dump, x, y, B, screen.scr[x][y].min[SB]);
			}
	
			else
			{
				assval(two_dump, x, y, R, 0);
				assval(two_dump, x, y, G, 0);
				assval(two_dump, x, y, B, screen.scr[x][y].complete_edge);
			}
		}
	}
}

else if(m == 2)
{
	for(x = 0; x < XSIZE; x++)
	{
		for(y = 0; y < YSIZE; y++)
		{
			if(screen.scr[x][y].complete_edge == 0)
			{
				assval(two_dump, x, y, R, screen.scr[x][y].tot[SR] / screen.no_frames);
				assval(two_dump, x, y, G, screen.scr[x][y].tot[SG] / screen.no_frames);
				assval(two_dump, x, y, B, screen.scr[x][y].tot[SB] / screen.no_frames);
			}
	
			else
			{
				assval(two_dump, x, y, R, 0);
				assval(two_dump, x, y, G, 0);
				assval(two_dump, x, y, B, screen.scr[x][y].complete_edge);
			}
		}
	}
}

else if(m == 3)
{
	for(x = 0; x < XSIZE; x++)
	{
		for(y = 0; y < YSIZE; y++)
		{
			if(screen.scr[x][y].complete_edge == 0)
			{
				assval(two_dump, x, y, R, screen.scr[x][y].max_pos[SR]);
				assval(two_dump, x, y, G, screen.scr[x][y].max_pos[SG]);
				assval(two_dump, x, y, B, screen.scr[x][y].max_pos[SB]);
			}
	
			else
			{
				assval(two_dump, x, y, R, 0);
				assval(two_dump, x, y, G, 0);
				assval(two_dump, x, y, B, screen.scr[x][y].complete_edge);
			}
		}
	}
}

else
{
	for(x = 0; x < XSIZE; x++)
	{
		for(y = 0; y < YSIZE; y++)
		{
			if(screen.scr[x][y].complete_edge == 0)
			{
				assval(two_dump, x, y, R, screen.scr[x][y].min_pos[SR]);
				assval(two_dump, x, y, G, screen.scr[x][y].min_pos[SG]);
				assval(two_dump, x, y, B, screen.scr[x][y].min_pos[SB]);
			}
	
			else
			{
				assval(two_dump, x, y, R, 0);
				assval(two_dump, x, y, G, 0);
				assval(two_dump, x, y, B, screen.scr[x][y].complete_edge);
			}
		}
	}
}
}

/****************************************************************/
/*Resets the open windows when called.				*/
/****************************************************************/
void reset_id_proc(FL_OBJECT *n, long m)
{
if(m == 0)
{
	winset(overlay_win);
	put_overlay_pixels(id_current_image_flag);
	dump_image(two_dump);
	
	if(id_hist_flag == 0)
	{
		overlay_finished();
	}
}

else
{
	winset(id_win);
	put_overlay_pixels(id_current_image_flag);
	dump_image(two_dump);
	id_array_init();
	id_array_init2();
	id_mode_init();
	finished_id_flag = 0;
	id_flag = 0;
}
}

/****************************************************************/
/*Initializes arrays used in the id module.			*/
/****************************************************************/
void id_array_init2()
{
short x, y;

for(x = 0; x < XSIZE; x++)
{
	for(y = 0; y < YSIZE; y++)
	{
		id_pixel[x][y] = screen.scr[x][y].complete_edge;
		screen.types[x][y].mineral_type = 16;
	}	
}
}

/****************************************************************/
/*Initializes arrays used in the id module.			*/
/****************************************************************/
void id_array_init()
{
short x, y;

for(x = 0; x < 17; x++)
{
	current_colour[x] = 0;
	id_mode_r[x] = 0;
	id_mode_g[x] = 0;
	id_mode_b[x] = 0;
}
id_num_grains = 0;
}

/****************************************************************/
/*Initializes arrays used in the id module.			*/
/****************************************************************/
void id_mode_init()
{
short x, y;

for(x = 0; x < 256; x++)
{
	mode_r[x] = 0;
	mode_g[x] = 0;
	mode_b[x] = 0;
}
}

/****************************************************************/
/*Refreshes current view					*/
/****************************************************************/
void id_refresh_proc(FL_OBJECT *n, long m)
{
winset(id_win);
dump_image(two_dump);
winset(overlay_win);
dump_image(two_dump);
}

/****************************************************************/
/*sets initial mineral names.					*/
/****************************************************************/
void init_min_name()
{
fl_set_input(min_name_2,"biotite");
fl_set_input(min_name_3,"hornblende");
fl_set_input(min_name_4,"pyroxene");
fl_set_input(min_name_5,"muscovite");
fl_set_input(min_name_6,"garnet");
fl_set_input(min_name_7,"calcite");
fl_set_input(min_name_8,"fluorite");
fl_set_input(min_name_9,"kyanite");
fl_set_input(min_name_10,"olivine");
fl_set_input(min_name_11,"epidote");
fl_set_input(min_name_12,"apatite");
fl_set_input(min_name_13,"k-feldspar");
fl_set_input(min_name_14,"plag");
fl_set_input(min_name_15,"opaque");

min_name_change[0] = "biotite";
min_name_change[1] = "hornblende";
min_name_change[2] = "pyroxene";
min_name_change[3] = "muscovite";
min_name_change[4] = "garnet";
min_name_change[5] = "calcite";
min_name_change[6] = "fluorite";
min_name_change[7] = "kyanite";
min_name_change[8] = "olivine";
min_name_change[9] = "epidote";
min_name_change[10] = "apatite";
min_name_change[11] = "k-feldspar";
min_name_change[12] = "plag";
min_name_change[13] = "opaque";
min_name_change[14] = "quartz";
}

/****************************************************************/
/*Displays mineral identification code form			*/
/****************************************************************/
void show_id_code_proc(FL_OBJECT *n, long m)
{
fl_show_form(min_id_form,FL_PLACE_CENTER,TRUE,"GeoVision");
fl_freeze_form(min_id_form);
fl_show_object(min_id_grp);
fl_unfreeze_form(min_id_form);
}

/****************************************************************/
/*Changes mineral id names.					*/
/****************************************************************/
void min_code_apply_proc(FL_OBJECT *n, long m)
{
min_name_change[0] = fl_get_input(min_name_2);
min_name_change[1] = fl_get_input(min_name_3);
min_name_change[2] = fl_get_input(min_name_4);
min_name_change[3] = fl_get_input(min_name_5);
min_name_change[4] = fl_get_input(min_name_6);
min_name_change[5] = fl_get_input(min_name_7);
min_name_change[6] = fl_get_input(min_name_8);
min_name_change[7] = fl_get_input(min_name_9);
min_name_change[8] = fl_get_input(min_name_10);
min_name_change[9] = fl_get_input(min_name_11);
min_name_change[10] = fl_get_input(min_name_12);
min_name_change[11] = fl_get_input(min_name_13);
min_name_change[12] = fl_get_input(min_name_14);
min_name_change[13] = fl_get_input(min_name_15);
		
fl_freeze_form(main_form);
fl_set_object_label(id_but_2, min_name_change[0]);
fl_set_object_label(id_but_3, min_name_change[1]);
fl_set_object_label(id_but_4, min_name_change[2]);
fl_set_object_label(id_but_5, min_name_change[3]);
fl_set_object_label(id_but_6, min_name_change[4]);
fl_set_object_label(id_but_7, min_name_change[5]);
fl_set_object_label(id_but_8, min_name_change[6]);
fl_set_object_label(id_but_9, min_name_change[7]);
fl_set_object_label(id_but_10, min_name_change[8]);
fl_set_object_label(id_but_11, min_name_change[9]);
fl_set_object_label(id_but_12, min_name_change[10]);
fl_set_object_label(id_but_13, min_name_change[11]);
fl_set_object_label(id_but_14, min_name_change[12]);
fl_set_object_label(id_but_15, min_name_change[13]);
fl_unfreeze_form(main_form);
}

/****************************************************************/
/*Closes mineral id code form without saving changes.		*/
/****************************************************************/
void min_code_done_proc(FL_OBJECT *n, long m)
{
fl_freeze_form(min_id_form);
fl_hide_object(min_id_grp);
fl_unfreeze_form(min_id_form);
fl_hide_form(min_id_form);
}

/****************************************************************/
/*Closes id menu and exits back to main menu.			*/
/****************************************************************/
void id_done_proc(FL_OBJECT *n, long m)
{
winclose(id_win);
id_win = -1;
winclose(overlay_win);
overlay_win = -1;
id_flag = 0;
id_current_image_flag = 1;
finished_id_flag = 0;
id_num_grains = 0;

if(id_hist_flag != 0)
{
	winclose(id_hist_win);
	id_hist_win = -1;
	id_hist_flag = 0;
}
	
fl_unqdevice(LEFTMOUSE);
fl_set_event_call_back(id_dummy_callback);
fl_hide_object(id1_grp);
fl_hide_object(id2_grp);
fl_show_object(main_grp);
}
