#include <gl/gl.h>
#include <stdio.h>
#include <gl/device.h>
#include "image.h"
#include "basic_imm.h"
#include "pers.h"
#include "manual.h"
#include "twoD.h"
#include <malloc.h>

#define GL_SIZE	2
#define V_FOV	400
#define ROT_R 'x'
#define ROT_G 'y'
#define ROT_B 'z'
#define ANGLE_STEP 10;
#define MAX_RATIO 1.4142136
#define MAN_SIZE 130
#define BOX_SIZE 25
#define BOX_START 128
#define R_MAX 1
#define R_MIN 2
#define G_MAX 3
#define G_MIN 4
#define B_MAX 5
#define B_MIN 6
#define B_UP 1
#define B_DOWN 2

#define BR 0
#define BG 1
#define BB 2


extern twotype *space1,*space2;
static int sp_1, sp_2;


static    int y, xsize, ysize;
static    int z, zsize;
    extern int density;

extern pointtype *disp_arr;
extern disp_size;
extern short box;

box_T *boxing;
box_T *curr_box;

unsigned short man_color = RED;

box_T *init_box(unsigned short color)
{
box_T *temp;

temp = calloc(1,sizeof(box_T));

temp->color= color;
temp->r_min= BOX_START-BOX_SIZE; 
temp->r_max = BOX_START+BOX_SIZE;
temp->g_min= BOX_START-BOX_SIZE; 
temp->g_max = BOX_START+BOX_SIZE;
temp->b_min= BOX_START-BOX_SIZE; 
temp->b_max = BOX_START+BOX_SIZE;
temp->prev = NULL;
temp->next = NULL;


return(temp);
}

void fix_box(box_T *box, int b_val, int direction, int step)
{
char *temp;
if (b_val == R_MAX) temp = &box->r_max;
if (b_val == R_MIN) temp = &box->r_min;
if (b_val == G_MAX) temp = &box->g_max;
if (b_val == G_MIN) temp = &box->g_min;
if (b_val == B_MAX) temp = &box->b_max;
if (b_val == B_MIN) temp = &box->b_min;

if (direction==B_UP) 
{
	if ((int)*temp + step <=255)
		*temp += step;
	else
		*temp = 255;
}
else
{
	if ((int)*temp - step >=0)
		*temp -= step;
	else
		*temp = 0;
}
}

void b_move(box_T *box, int b_val, int direction, int step)
{
char *temp;

/* Picking the plane of the box that will move */

if (b_val == R_MAX) temp = &box->r_min;
if (b_val == R_MIN) temp = &box->r_min;
if (b_val == G_MAX) temp = &box->g_min;
if (b_val == G_MIN) temp = &box->g_min;
if (b_val == B_MAX) temp = &box->b_min;
if (b_val == B_MIN) temp = &box->b_min;

if (direction==B_UP)
{
        if ((int)*(temp+1) + step <=255)
	{
                *temp += step;
		*(temp+1) += step;
	}
        else
	{
		*temp += 255-*(temp+1);
                *(temp+1) = 255;
	}
}
else
{
        if ((int)*temp - step >=0)
	{
                *temp -= step;
		*(temp+1) -= step;
	}
        else
	{
		*(temp+1) -= *temp;
                *temp = 0;
	}
}
}

new_box(box_T **curr_box, unsigned short color)
{
box_T *temp;

temp = init_box(color);
if (*curr_box != NULL)
{
	(*curr_box)->next = temp;
	temp->prev = *curr_box;
	*curr_box = temp;
}
else
	*curr_box = temp;
}

blank_box(box_T *l_box, pointtype *disp, long size,unsigned short color)
{
long i;

for(i=0; i<size; i++)
{
if (in_box(l_box,disp[i][0],disp[i][1],disp[i][2])== TRUE)
	disp[i][3] = (char) color;
}
}

int del_box(box_T **curr, unsigned short *color)
{
box_T *temp;

if((*curr)->prev != NULL)
{
	temp = (*curr);
	(*curr) = temp->prev;
	(*curr)->next = temp->next;
	if (temp->next != NULL)
		(temp->next)->prev = (*curr);
	free(temp);
	*color = (*curr)->color;
	return(TRUE);
}
else if((*curr)->next != NULL)
{
	temp = (*curr);
	(*curr) = temp->next;
	if(temp->prev != NULL)
		(temp->prev)->next = temp->next;
	(*curr)->prev = temp->prev;
	free(temp);
	*color = (*curr)->color;
	return(TRUE); 
}
return(FALSE);
} 

update_boxing(box_T *box, box_T *curr, int color) 
{ 
while(box != NULL)
{
	if (color == BLACK)
	{
		if (box->next != NULL)
			blank_box(box,disp_arr,disp_size,color);
	}
	else
	{
		if (box != curr)
			blank_box(box,disp_arr,disp_size,box->color);
	}
	box = box->next;
	}
}

void do_manual(char *string)
{
int temp = 1;
curr_box = boxing = NULL;
if (0)
{
/*
	load_box(string,&boxing,&curr_box);
*/
	man_color = curr_box->color;
	update_boxing(boxing, curr_box, BLACK);
fprintf(stderr,"box = %d, cur = %d\n",boxing->r_min,curr_box->color);
}
else
{
	curr_box = boxing = init_box(man_color);
fprintf(stderr,"curretn = %d\n",curr_box);
}

while(1)
{
        if (temp == 1)
                if(man_ident() == 1)
                        temp = 2;
                else
                        break;
        else
	{
fprintf(stderr,"do_man curr = %d\n",curr_box);
                if(do_twoD(*space1, boxing) == 1)
                        temp = 1;
                else
                        break;
	}
}
/*
save_box(string,boxing);
*/
}

int man_ident()
{
int angle;
long cmd;
short val, all = 0;
char c= ROT_G;
int redisplay = TRUE, mama;
int b_val=1, b_step=4;
char move = TRUE;

        prefsize(700,700);
	winopen("spin");
        mmode(MVIEWING);
        perspective(V_FOV, 1, 50, 1000);
        lookat(0,00,600,0,0,0,0);
/*
	ortho(MAX_RATIO*-MAN_SIZE,MAX_RATIO*MAN_SIZE,
		-MAN_SIZE,MAN_SIZE,
		MAX_RATIO*-MAN_SIZE, MAX_RATIO*MAN_SIZE);
*/
	doublebuffer();
	gconfig();

	color(BLACK); 
	clear(); 
	swapbuffers();
	color(BLACK);
	clear();
	angle = 0;

put_box();
qdevice(KEYBD);
	for(;;)
	{
		if (qtest())
		{
			cmd = qread(&val);
			if (val)
			{
			switch(cmd)
			{
				case ESCKEY:
				case WINSHUT:
				case WINQUIT:
					gexit();
					return 0;
					break;
				case MOUSE1:
					angle += ANGLE_STEP;
					break;
				case MOUSE2:
					angle = 0;
					break;
				case MOUSE3:
					angle -= ANGLE_STEP;
					break;
				case SPACEKEY:
					if (box==0) box =1;
					else box = 0;
					break;
				case AKEY:
					if (all == 0)
					{
						update_boxing(boxing,curr_box,WHITE);
						all = 1;
					}
					else
					{
						update_boxing(boxing,curr_box,BLACK);
						all = 0;
					}
					break;
				case RKEY:
					c=ROT_R; 
					qread(&val);
					if (val == 'R') 
						b_val=R_MAX;
					else
						b_val=R_MIN;
					break;
				case GKEY:
					c= ROT_G;
					qread(&val);
					if (val == 'G')
                                                b_val=G_MAX;
                                        else
                                                b_val=G_MIN;
					break;
				case BKEY:
					c = ROT_B;
					qread(&val);
                                        if (val == 'B')
                                                b_val=B_MAX;
                                        else
                                                b_val=B_MIN;
					break;
                                case SKEY:
                                        gexit();
                                        return(1);
                                        break;
				case ONEKEY:
					b_step = 4;
					break;
				case TWOKEY:
					b_step = 8;
					break;
				case THREEKEY:
					b_step = 16;
					break;
				case FOURKEY:
					b_step = 32;
					break;
				case MKEY:
					if (move == TRUE)
						move = FALSE;
					else
						move = TRUE;
					break; 
				case NKEY:
					man_color++;
					blank_box(curr_box,disp_arr,disp_size,BLACK);
					new_box(&curr_box,man_color);
					break;
				case RETKEY:
					blank_box(curr_box,disp_arr,disp_size,BLACK);
                                        new_box(&curr_box,man_color);
                                        break;
			case BACKSPACEKEY:
				if (del_box(&curr_box,&man_color) == TRUE)
					blank_box(curr_box,disp_arr,disp_size,WHITE);
				break;
				
				case UPARROWKEY:
					if (move)
					    b_move(curr_box,b_val,B_UP,b_step);
					else
					    fix_box(curr_box,b_val,B_UP,b_step);
					break;
				case DOWNARROWKEY:
					if (move)
					  b_move(curr_box,b_val,B_DOWN,b_step);
					else
					  fix_box(curr_box,b_val,B_DOWN,b_step);
					break;
			case LEFTARROWKEY:
				if (curr_box->prev != NULL)
				{ 
				blank_box(curr_box,disp_arr,disp_size,BLACK); 
				curr_box = curr_box->prev;
				man_color = curr_box->color;
				blank_box(curr_box,disp_arr,disp_size,WHITE);
				}
				break;
			case RIGHTARROWKEY:
				if (curr_box->next != NULL)
				{
				blank_box(curr_box,disp_arr,disp_size,BLACK);
				curr_box = curr_box->next;
				man_color = curr_box->color;
				blank_box(curr_box,disp_arr,disp_size,WHITE);
				}
				break;
			default:
				break;
			}
			}
		}
		if (redisplay == TRUE)
		{
			rotate(angle, c);
			display_data_2(disp_arr,disp_size,curr_box);
		}
		else
		{
			printf("halted density = %d\n", density);
		}
		if (density <= 2)
			redisplay = FALSE;
		else
			redisplay = TRUE;
	}
}

