#include <stdlib.h> 
#include <stdio.h>
#include <math.h>
#include <gl/gl.h>
#include "forms.h" 
#include "gv_forms.h" 
#include "types.h" 
#include "stage.h" 
#include "measure.h"

extern char two_dump[XSIZE][YSIZE][3];
extern screenT screen;
extern short protected[XSIZE][YSIZE];
extern long measure_win;

short max_caxis = 255;

static int num_times;
static long num_pix;
static char toggle_flag = 0;
static char border_grain;

static long Mxx_accumulator, Mxy_accumulator, Myy_accumulator;
static long Mxx, Mxy, Myy;
static long surface_area, sum_x, sum_y;
static double spo_length1, spo_length2;
static double spo_angle;

static char inertia_flag = 0;
static long c_axis_win = -1;
static char c_axis_flag = 0;

extern char *min_name_change[14];

/********************************************************************/
/*Recursively fills a bounded region with colour defined by colour. */
/********************************************************************/
void boundary_fill(short x, short y, short boundary, short new, short colour)
{
char check;

check = valat(two_dump, x, y, colour);
if( (check != boundary)	 
&&(check != new) )
{
	assval(two_dump, x, y, colour, 155);
	num_pix++;
	screen.types[x][y].grain_number = num_times;
	protected[x][y] = num_times;
		
	boundary_fill(x - 1, y, 255, 155, colour);
	boundary_fill(x + 1, y, 255, 155, colour);
	boundary_fill(x, y - 1, 255, 155, colour);
	boundary_fill(x, y + 1, 255, 155, colour);
}
}

/********************************************************************/
/*Calls boundary fill procedure and sets value of colour.	    */
/********************************************************************/
void boundary_fill_image_proc(FL_OBJECT *n, long m)
{
short x, y, colour = G;
short xpos, ypos;

num_times = 0;
for(x = 0; x < XSIZE; x++)
{
	for(y = 0; y < YSIZE; y++)
	{
		screen.types[x][y].grain_number = 0;
	}
}

for(x = 6; x < XSIZE - 6; x++)
{
	for(y = 6; y < YSIZE - 6; y++)
	{
		if( (valat(two_dump, x, y, R) == 0)
		&&(valat(two_dump, x, y, G) == 0)
		&&(valat(two_dump, x, y, B) == 0) )
		{
			if(colour == R)
				colour = G;

			else if(colour == G)
				colour = B;
	
			else
				colour = R;
			
			num_times++;
			num_pix = 0;
			boundary_fill(x, y, 255, 155, colour);
		
			if( (num_pix < 10)
			||(num_pix > 1000) )
			{
				for(xpos = 0; xpos < XSIZE; xpos++)
				{
					for(ypos = 0; ypos < YSIZE; ypos++)
					{
						if((long)protected[xpos][ypos] == num_times)
						{
							protected[xpos][ypos] = 0;
						}
					}
				}
			}
		}
	}
}
dump_image(two_dump);
screen.num_grains = num_times;
fprintf(stderr,"%d\n",num_times);
}

/********************************************************************/
/*Calls boundary fill procedure and sets value of colour.	    */
/********************************************************************/
void matrix_fill_image()
{
short x, y, colour = G;
short xpos, ypos;

num_times = 0;
for(x = 0; x < XSIZE; x++)
{
	for(y = 0; y < YSIZE; y++)
	{
		screen.types[x][y].grain_number = 0;
	}
}

for(x = 6; x < XSIZE - 6; x++)
{
	for(y = 6; y < YSIZE - 6; y++)
	{
		if( (valat(two_dump, x, y, R) == 0)
		&&(valat(two_dump, x, y, G) == 0)
		&&(valat(two_dump, x, y, B) == 0) )
		{
			if(colour == R)
				colour = G;

			else if(colour == G)
				colour = B;
	
			else
				colour = R;
			
			num_times++;
			num_pix = 0;
			boundary_fill(x, y, 255, 155, colour);
			dump_image(two_dump);
		
			if(num_pix < 100)
			{
				for(xpos = 0; xpos < XSIZE; xpos++)
				{
					for(ypos = 0; ypos < YSIZE; ypos++)
					{
						if((long)protected[xpos][ypos] == num_times)
						{
							protected[xpos][ypos] = 0;
						}
					}
				}
			}
		}
	}
}
screen.num_grains = num_times;
}

/********************************************************************/
/*Finds best fit ellipse for each closed contour in the image.	    */
/********************************************************************/
void inertia_tensor_proc(FL_OBJECT *n, long m)
{
short x, y, origin_x, origin_y;
short x_center, y_center;
double angle, length1, length2;
double pi = (2.0 * acos(0.0));
double Mxx_sum, Myy_sum, Mxy_sum;
int num_grains;
char *fname;
FILE *inertia_file;

if(m == 1)
{
	fname = fl_show_file_selector("File To Save","","*.dat","");

	if(fname == NULL)
		return;

	if((inertia_file = fopen(fname,"w")) == NULL)
	{
		fprintf(stderr,"error opening file\n");
		exit(0);
	}
	
	fprintf(inertia_file," 0 = Not identified\n");
	fprintf(inertia_file," 1 = %s\n",min_name_change[14]);
	for(x = 0; x < 14; x++)
	{
		fprintf(inertia_file,"%2d = %s\n",x+2,min_name_change[x]);
	}

	fprintf(inertia_file,"%s\t%s\t%s\t%s\t%s\t%s\t%s\t%s\t%s\t%s\t%s\t%s"
		,"#","TYPE","X","Y","AREA","Mxx","Mxy","Myy","ANGLE","L1","L2","ASPECT");
}

inertia_flag = 1;
num_grains = 0;	
Mxx_sum = 0.0;
Myy_sum = 0.0;
Mxy_sum = 0.0;

for(x = 6; x < XSIZE - 6; x++)
{
	for(y = 6; y < YSIZE - 6; y++)
	{
		if(screen.scr[x][y].complete_edge == 0)
		{
			origin_x = x;
			origin_y = y;
			
			Mxx_accumulator = 0;	/*initialize*/ 		
			Mxy_accumulator = 0; 		
			Myy_accumulator = 0;
			surface_area = 0;
			sum_x = 0; 		
			sum_y = 0;
			border_grain = 0; 		

			inertia_tensor_fill(x, y, origin_x, origin_y, 255, 155);

			if((surface_area > 1)
			&&(border_grain == 0) )
			{
				num_grains++;

				x_center = sum_x / surface_area;
				y_center = sum_y / surface_area;
			
				Mxx = (Mxx_accumulator / surface_area) - (x_center * x_center);
				Mxy = (Mxy_accumulator / surface_area) - (x_center * y_center);
				Myy = (Myy_accumulator / surface_area) - (y_center * y_center);
			
				angle = atan2((double)(2.0 * Mxy), (double)(Mxx - Myy));
				angle = angle / 2.0;

				length1 = (double)(Mxx * cos(angle) * cos(angle) + 
					 Myy * sin(angle) * sin(angle) +
					 Mxy * sin(2.0 * angle));
				
				length2 = (double)(Mxx * sin(angle) * sin(angle) + 
					 Myy * cos(angle) * cos(angle) -
					 Mxy * sin(2.0 * angle));

				angle *= 180.0 / pi;
				angle -= 90.0;

				while(angle < 0.0)
					angle += 180.0;

				while(angle >= 180.0)
					angle -= 180.0;
				
				length1 = 2.0 * sqrt(abs(length1));
				length2 = 2.0 * sqrt(abs(length2));
				
				Mxx_sum = Mxx_sum + Mxx;
				Myy_sum = Myy_sum + Myy;
				Mxy_sum = Mxy_sum + Mxy;
				 
				if(m == 1)
				{
		fprintf(inertia_file,"\n%d\t%d\t%d\t%d\t%d\t%ld\t%ld\t%ld\t%3.2lf\t%3.2lf\t%3.2lf\t%3.2lf",
						screen.types[x][y].grain_number,
						screen.types[x][y].mineral_type,
						x_center + origin_x, 
						y_center + origin_y, 
						surface_area, 
						Mxx,
						Mxy,
						Myy,
						angle, 
						length1, 
						length2,
						length1/length2);
				}

				if(surface_area < 100000)
				{
					fit_lines(0, 255, 0, x_center + origin_x, y_center +
						origin_y, angle, length2, length1, pi);
				}
			}
		}
	}
}

if(num_grains > 0)
{
	Mxx_sum = Mxx_sum / (double)num_grains;			
	Myy_sum = Myy_sum / (double)num_grains;			
	Mxy_sum = Mxy_sum / (double)num_grains;
}			

spo_angle = atan2((double)(2.0 * Mxy_sum), (double)(Mxx_sum - Myy_sum));
spo_angle = spo_angle / 2.0;

spo_length1 = (double)(Mxx_sum * cos(spo_angle) * cos(spo_angle) +
	      Myy_sum * sin(spo_angle) * sin(spo_angle) + 
	      Mxy_sum * sin(2.0 * spo_angle)); 

spo_length2 = (double)(Mxx_sum * sin(spo_angle) * sin(spo_angle) +
	      Myy_sum * cos(spo_angle) * cos(spo_angle) - 
	      Mxy_sum * sin(2.0 * spo_angle)); 

spo_angle *= 180.0 / pi;
spo_angle -= 90.0;

while(spo_angle < 0.0)
	spo_angle += 180.0;

while(spo_angle >= 180.0)
	spo_angle -= 180.0;

spo_length1 = 2.0 * sqrt(abs(spo_length1));
spo_length2 = 2.0 * sqrt(abs(spo_length2));

/*Clear the filled regions (filled in memory) from memory.*/
/*These regions are the interiors of the closed contours*/
/*filled by the inertia_tensor_fill(...) routine.*/
for(x = 0; x < XSIZE; x++)
{
	for(y = 0; y < YSIZE; y++)
	{
		if(screen.scr[x][y].complete_edge == 155)
		{
			screen.scr[x][y].complete_edge = 0;
		}
	}
}
if(m == 1)
	fclose(inertia_file);
}

/********************************************************************/
/*Recursively fills a bounded region with colour Red 155. 	    */
/********************************************************************/
void inertia_tensor_fill(short x, short y, short xo, short yo, char boundary, char new)
{
char check;

if(x <= 6 || x >= 633 || y <= 6 || y >= 479)
{ 
	border_grain = 1;
}

check = screen.scr[x][y].complete_edge;
if( (check != boundary)	 
&&(check != new) )
{
	screen.scr[x][y].complete_edge = 155;
	Mxx_accumulator += (x - xo) * (x - xo); 		
	Mxy_accumulator += (x - xo) * (y - yo); 		
	Myy_accumulator += (y - yo) * (y - yo);
	surface_area += 1;
	sum_x += (x - xo); 		
	sum_y += (y - yo); 		
		
	inertia_tensor_fill(x - 1, y, xo, yo, 255, 155);
	inertia_tensor_fill(x, y - 1, xo, yo, 255, 155);
	inertia_tensor_fill(x, y + 1, xo, yo, 255, 155);
	inertia_tensor_fill(x + 1, y, xo, yo, 255, 155);
}
}

/********************************************************************/
/*Plots SPO on screen.						    */
/********************************************************************/
void spo_proc(FL_OBJECT *n, long m)
{
short x, y;
double temp;
	
for(x = 0; x < XSIZE; x++)
{
	for(y = 0; y < YSIZE; y++)
	{
		assval(two_dump, x, y, R, 0);
		assval(two_dump, x, y, G, 0);
		assval(two_dump, x, y, B, 0);
	}
}
dump_image(two_dump);

temp = spo_angle;
fit_lines(0, 255, 0, 320, 243, temp, spo_length2, spo_length1, 3.141592654);
/*
spo_angle = 90.0 + spo_angle;
if(spo_angle > 180.0)
	spo_angle = spo_angle - 180.0;
*/
for(x = 0; x < XSIZE; x++)
{
	for(y = 0; y < YSIZE; y++)
	{
		assval(two_dump, x, y, R, screen.scr[x][y].complete_edge);
		assval(two_dump, x, y, G, screen.scr[x][y].complete_edge);
		assval(two_dump, x, y, B, screen.scr[x][y].complete_edge);
	}
}
}

/********************************************************************/
/*Draws best fit ellipse for mineral grain inside outlined edges    */
/*of the mineral grain.						    */
/********************************************************************/
void fit_lines(char r, char g, char b, short x, short y, double angle, 
		double length1, double length2, double pi)
{
int x_proj, y_proj;
double angle_in_rad;
long vector[2];
long cv[3];

linewidth(2);
/*long axis of ellipse*/
angle_in_rad = angle * pi / 180.0;
x_proj = (int)(length1 * cos(angle_in_rad));
y_proj = (int)(length1 * sin(angle_in_rad));

cv[0] = r;
cv[1] = g;
cv[2] = b;
c3i(cv);
bgnline();
vector[0] = (x + x_proj);
vector[1] = YSIZE - (y + y_proj);
v2i(vector);
vector[0] = (x - x_proj);
vector[1] = YSIZE - (y - y_proj);
v2i(vector);
endline();
gflush();

/*short axis of ellipse*/
angle_in_rad = (angle + 90.0) * pi / 180.0;
x_proj = (int)(length2 * cos(angle_in_rad));
y_proj = (int)(length2 * sin(angle_in_rad));

cv[0] = 255;
cv[1] = 0;
cv[2] = 0;
c3i(cv);
bgnline();
vector[0] = (x + x_proj);
vector[1] = YSIZE - (y + y_proj);
v2i(vector);
vector[0] = (x - x_proj);
vector[1] = YSIZE - (y - y_proj);
v2i(vector);
endline();
gflush();
linewidth(1);
}

/********************************************************************/
/*Removes edges from current GL window to allow user to view only   */
/*the best fit ellipse of each grain, or replaces edges if they were*/
/*removed (by this routine).					    */
/********************************************************************/
void m_toggle_edges_proc(FL_OBJECT *n, long m) 
{
short x, y;

for(x = 0; x < XSIZE; x++)
{
	for(y = 0; y < YSIZE; y++)
	{
		if(screen.scr[x][y].complete_edge > 0)
		{
			if(toggle_flag == 0)
			{
				assval(two_dump, x, y, R, 0);	
				assval(two_dump, x, y, G, 0);	
				assval(two_dump, x, y, B, 0);
			}

			else
			{
				assval(two_dump, x, y, R, 255);	
				assval(two_dump, x, y, G, 255);	
				assval(two_dump, x, y, B, 255);
			}
		}
	}
}
if(toggle_flag == 0)
{
	toggle_flag = 1;
}

else
{
	toggle_flag = 0;
}
dump_image(two_dump);

for(x = 0; x < XSIZE; x++)
{
	for(y = 0; y < YSIZE; y++)
	{
		assval(two_dump, x, y, R, screen.scr[x][y].complete_edge);	
		assval(two_dump, x, y, G, screen.scr[x][y].complete_edge);	
		assval(two_dump, x, y, B, screen.scr[x][y].complete_edge);
	}
}
inertia_tensor_proc(NULL, 0);
}
				
/********************************************************************/
/*Refreshes measure window.					    */
/********************************************************************/
void measure_refresh_proc(FL_OBJECT *n, long m)
{
dump_image(two_dump);
toggle_flag = 0;

if(c_axis_flag == 1)
{
	quartz_c_axis_proc(NULL, 0);
}

else
/*
if(inertia_flag == 1)
*/
{
	inertia_tensor_proc(NULL, 0);
}
}

/********************************************************************/
/*Quatrz C-axis starts here.					    */
/********************************************************************/
void quartz_c_axis_proc(FL_OBJECT *n, long m)
{
short x, y, counter;
float vector[2];
double new_angle;
double pi = 2.0 * acos(0.0);

if(c_axis_win == -1)
{
	c_axis_flag = 1;
	counter = 0;
	for(x = 0; x < XSIZE; x++)
	{
		for(y = 0; y < YSIZE; y++)
		{
			if(screen.types[x][y].mineral_type == QUARTZ)
			{
				counter++;
			}
		}
	}

	if(counter == 0)
	{
		fl_show_message("","NO QUARTZ GRAINS IDENTIFIED!","");
	}

	prefsize(400, 400);
	c_axis_win = winopen("C-AXIS STEREO PLOT");
	ortho2(-1.1, 1.1, -1.1, 1.1);
	gconfig();
}		

else
{
	winset(c_axis_win);
}

color(BLACK);
clear();
color(WHITE);
circ(0, 0, 1);
		
bgnline();
vector[0] = 0.0;
vector[1] = 1.05;
v2f(vector); 		
vector[0] = 0.0;
vector[1] = -1.0;
v2f(vector); 		
endline();
		
bgnline();
vector[0] = -1.0;
vector[1] = 0.0;
v2f(vector); 		
vector[0] = 1.0;
vector[1] = 0.0;
v2f(vector); 		
endline();
		
if(fl_get_button(c_every_pix_but) == 1)
	trend_and_plunge_every_pix();

if(fl_get_button(c_grid_but) == 1)
	trend_and_plunge_grid(m);

if(fl_get_button(c_every_grain_but) == 1)
	trend_and_plunge_every_grain(m, 0);

if(fl_get_button(c_every_grain_norm_but) == 1)
	trend_and_plunge_every_grain(m, 1);

if(inertia_flag == 1)
{
	new_angle = spo_angle;
	new_angle = 90.0 + new_angle;
	if(new_angle > 180.0)
		new_angle = new_angle - 180.0;
	new_angle = new_angle * pi / 180.0;

	color(MAGENTA);
	bgnline();
	vector[0] = sin(new_angle);
	vector[1] = cos(new_angle);
	v2f(vector); 		
	vector[0] = -sin(new_angle);
	vector[1] = -cos(new_angle);
	v2f(vector);
	endline();
}
gflush();
winset(measure_win);
}
	
/********************************************************************/
/*Calculates the trend and plunge of quartz c_axis in the sample.   */
/********************************************************************/
void trend_and_plunge_every_pix()
{
short x, y;
float max_pos_in_deg[XSIZE][YSIZE];
float pi = (2.0 * acos(0.0));
float x_schmidt[XSIZE][YSIZE];
float y_schmidt[XSIZE][YSIZE];
float vector[2];
float c_trend[XSIZE][YSIZE];
float c_plunge[XSIZE][YSIZE];

/*max_blue = 0;*/
for(x = 0; x < XSIZE; x++)
{
	for(y = 0; y < YSIZE; y++)
	{
		c_trend[x][y] = -1.0;
		c_plunge[x][y] = -1.0;
		max_pos_in_deg[x][y] = 0.0;
		x_schmidt[x][y] = 2.0;
		y_schmidt[x][y] = 2.0;
		
		/*
		if( (screen.scr[x][y].complete_edge == 0)
		&&(screen.scr[x][y].max[SR] > max_red) )
		{
			max_red = screen.scr[x][y].max[SR];
		}
		*/
	}
}

for(x = 7; x < XSIZE - 7; x++)
{
	for(y = 7; y < YSIZE - 7; y++)
	{
		if( (screen.types[x][y].mineral_type == QUARTZ)
		&&(screen.scr[x][y].complete_edge == 0) )
		{
			max_pos_in_deg[x][y] =(float)((float)screen.scr[x][y].max_pos[SR]*0.9);
			if(max_pos_in_deg[x][y] <= 45.0)
			{
				c_trend[x][y] = max_pos_in_deg[x][y] + 135.0;
			}

			else
			{
				c_trend[x][y] = max_pos_in_deg[x][y] - 45.0; 
			}
			
			c_plunge[x][y] = (0.5*acos((2.0*(float)((float)screen.scr[x][y].max[SR]/
					(float)max_caxis))-1.0));

			if(c_plunge[x][y] < 0.0)
			{
				c_plunge[x][y] = 0.0;
			}

			if(c_plunge[x][y] > (pi/2.0))
			{
				c_plunge[x][y] = pi/2.0;
			}
		}
	}
}

for(x = 7; x < XSIZE - 7; x++)
{
	for(y = 7; y < YSIZE - 7; y++)
	{
		if( (c_trend[x][y] >= 0.0)
		&&(screen.scr[x][y].complete_edge == 0) )
		{
			c_plunge[x][y] = (pi/2.0 - c_plunge[x][y]);			
			c_plunge[x][y] = sqrt(1 - (cos(c_plunge[x][y])));
		
			c_trend[x][y] = c_trend[x][y] * pi / 180.0;
			x_schmidt[x][y] = c_plunge[x][y] * (sin(c_trend[x][y]));
			y_schmidt[x][y] = c_plunge[x][y] * (cos(c_trend[x][y]));
		}
	}
}

color(RED);
bgnpoint();
for(x = 7; x < XSIZE - 7; x++)
{
	for(y = 7; y < YSIZE - 7; y++)
	{
		if( (x_schmidt[x][y] < 2.0)
		&&(screen.scr[x][y].complete_edge == 0) )
		{
			vector[0] = x_schmidt[x][y];
			vector[1] = y_schmidt[x][y];
			v2f(vector);	
			vector[0] = -x_schmidt[x][y];
			vector[1] = -y_schmidt[x][y];
			v2f(vector);	
		}
	}
}
endpoint();
gflush();
}

/********************************************************************/
/*Calculates the trend and plunge of quartz c_axis in the sample.   */
/********************************************************************/
void trend_and_plunge_grid(long tosave)
{
short x, y, xpos, ypos;
char *input[2];
int grid_x, grid_y, counter, numb;
float max_pos_in_deg[3000];
float pi = (2.0 * acos(0.0));
float x_schmidt[3000];
float y_schmidt[3000];
float vector[2];
float c_trend[3000];
float c_plunge[3000];
short x_cent[3000];
short y_cent[3000];
long mode_max[256];
long mode_max_pos[256];
long max_mode_max;
long max_mode_max_pos;
short mode_m[3000], mode_p[3000];
char *fname;
FILE *grid_file;

if(tosave == 1)
{
	fname = fl_show_file_selector("File To Save","","*.dat","");

	if(fname == NULL)
		return;

	if((grid_file = fopen(fname,"w")) == NULL)
	{
		fprintf(stderr,"error opening file\n");
		exit(0);
	}
	fprintf(grid_file,"%s\t%s","TREND","PLUNGE");
}

for(x = 0; x < 256; x++)
{
	mode_max[x] = 0;
	mode_max_pos[x] = 0;
}

for(x = 0; x < 3000; x++)
{
	c_trend[x] = -1.0;
	c_plunge[x] = -1.0;
	max_pos_in_deg[x] = 0.0;
	x_schmidt[x] = 2.0;
	y_schmidt[x] = 2.0;
	x_cent[x] = 0;
	y_cent[x] = 0;
	mode_p[x] = 0;
	mode_m[x] = 0;
}

input[0] = fl_get_input(grid_input_x);
input[1] = fl_get_input(grid_input_y);

sscanf(input[0],"%d",&grid_x);
sscanf(input[1],"%d",&grid_y);

if(grid_x > 100)
{
	grid_x = 100;
	fl_set_input(grid_input_x, "100");
	fl_show_message("","Maximum X dimension is 100 pixels.","");
}

if(grid_y > 100)
{
	grid_y = 100;
	fl_set_input(grid_input_y, "100");
	fl_show_message("","Maximum Y dimension is 100 pixels.","");
}

if(grid_x < 10)
{
	grid_x = 10;
	fl_set_input(grid_input_x, "10");
	fl_show_message("","Minimum X dimension is 10 pixels.","");
}

if(grid_y < 10)
{
	grid_y = 10;
	fl_set_input(grid_input_y, "10");
	fl_show_message("","Minimum Y dimension is 10 pixels.","");
}

numb = 0;

for(x = grid_x + 2; x < XSIZE - grid_x - 2; x+=grid_x)
{
	for(y = grid_y + 2; y < YSIZE - grid_y - 2; y+=grid_y)
	{
		counter = 0;
		for(xpos = x - grid_x/2; xpos < x + grid_x/2; xpos++)
		{	
			for(ypos = y - grid_y/2; ypos < y + grid_y/2; ypos++)
			{	
				if( (screen.types[xpos][ypos].mineral_type == QUARTZ)
				&&(screen.scr[xpos][ypos].complete_edge == 0) )
				{
					counter++;
					mode_max[screen.scr[xpos][ypos].max[SR]]++;
					mode_max_pos[screen.scr[xpos][ypos].max_pos[SR]]++;
				}
			}
		}		

		if(counter > (grid_x * grid_y / 2) )
		{
			max_mode_max = 0;
			max_mode_max_pos = 0;
			for(xpos = 0; xpos < 256; xpos++)
			{	
				if(mode_max[xpos] > max_mode_max)
				{
					max_mode_max = mode_max[xpos];
					mode_m[numb] = xpos;
				} 

				if(mode_max_pos[xpos] > max_mode_max_pos)
				{
					max_mode_max_pos = mode_max_pos[xpos];
					mode_p[numb] = xpos;
				} 
				mode_max[xpos] = 0;
				mode_max_pos[xpos] = 0;
			}

			x_cent[numb] = x;
			y_cent[numb] = y;
			numb++;
		}
	}
}

/*
max_mode_m = 0;
for(x = 0; x < numb; x++)
{
	if(mode_m[x] > max_mode_m)
	{
		max_mode_m = mode_m[x];
	}
}
*/
winset(measure_win);

for(x = 0; x < numb; x++)
{
	max_pos_in_deg[x] = (float)((float)mode_p[x] * 0.9);
	
	if(max_pos_in_deg[x] <= 45.0)
	{
		c_trend[x] = max_pos_in_deg[x] + 135.0;
	}

	else
	{
		c_trend[x] = max_pos_in_deg[x] - 45.0; 
	}

	c_plunge[x] = 0.5*acos(2.0*(float)((float)mode_m[x]/(float)max_caxis)-1.0);

	if(c_plunge[x] < 0.0)
	{
		c_plunge[x] = 0.0;
	}

	if(c_plunge[x] > pi/2.0)
	{
		c_plunge[x] = pi/2.0;
	}
	
	if(tosave == 1)
	{
		fprintf(grid_file,"\n%3.2f\t%3.2f",c_trend[x],c_plunge[x]*180.0/pi);
	}

	c_plunge[x] = (pi/2.0 - c_plunge[x]);			
	c_plunge[x] = sqrt(1 - (cos(c_plunge[x])));

	c_trend[x] = c_trend[x] * pi / 180.0;

	fit_lines(255, 0, 0, x_cent[x], y_cent[x], (90.0 + (c_trend[x] * 180.0 /pi)), 
		 (20.0 * ( ((c_plunge[x] * 180.0 / pi) / 90.0)) ), 0.0, pi);

	x_schmidt[x] = c_plunge[x] * (sin(c_trend[x]));
	y_schmidt[x] = c_plunge[x] * (cos(c_trend[x]));
}
winset(c_axis_win);

color(GREEN);
for(x = 0; x < numb; x++)
{
	circ(x_schmidt[x], y_schmidt[x], 0.02); 
	circ(-x_schmidt[x], -y_schmidt[x], 0.02);
} 
gflush();

if(tosave == 1)
	fclose(grid_file);
}

/********************************************************************/
/*Calculates the trend and plunge of quartz c_axis in the sample.   */
/********************************************************************/
void trend_and_plunge_every_grain(long tosave, char is_normalized)
{
short x, y, xpos, ypos, tempx, tempy;
int numb;
float max_pos_in_deg[600];
float pi = (2.0 * acos(0.0));
float x_schmidt[600];
float y_schmidt[600];
float vector[2];
float c_trend[600];
float c_plunge[600];
int orig_x[600];
int orig_y[600];
int x_cent[600];
int y_cent[600];
unsigned long m_grain[600];
long mode_max[256];
long mode_max_pos[256];
long max_mode_max;
long max_mode_max_pos;
int mode_m[600], mode_p[600];
char *fname;
FILE *grain_file;

if(tosave == 2)
{
	fname = fl_show_file_selector("File To Save","","*.dat","");

	if(fname == NULL)
		return;

	if((grain_file = fopen(fname,"w")) == NULL)
	{
		fprintf(stderr,"error opening file\n");
		exit(0);
	}
	fprintf(grain_file,"%s\t%s","TREND","PLUNGE");
}

for(x = 0; x < 256; x++)
{
	mode_max[x] = 0;
	mode_max_pos[x] = 0;
}

for(x = 0; x < 600; x++)
{
	c_trend[x] = -1.0;
	c_plunge[x] = -1.0;
	max_pos_in_deg[x] = 0.0;
	x_schmidt[x] = 2.0;
	y_schmidt[x] = 2.0;
	m_grain[x] = 0;
	orig_x[x] = 0;
	orig_y[x] = 0;
	x_cent[x] = 0;
	y_cent[x] = 0;
	mode_m[x] = 0;
	mode_p[x] = 0;
}

numb = 0;
for(x = 0; x < XSIZE; x++)
{
	for(y = 0; y < YSIZE; y++)
	{
		if( (screen.scr[x][y].complete_edge == 0)
		&&(screen.types[x][y].mineral_type == QUARTZ) )
		{
			max_mode_max = 0;
			max_mode_max_pos = 0;
			tempx = x;
			tempy = y;
			
			sum_x = 0;
			sum_y = 0;
			num_pix = 0;
			orig_x[numb] = x;
			orig_y[numb] = y;

			c_axis_fill(x, y, tempx, tempy, mode_max, mode_max_pos, 100, 255);	
			
			m_grain[numb] = num_pix;
			x_cent[numb] = (int)(sum_x / num_pix);
			y_cent[numb] = (int)(sum_y / num_pix);

			for(xpos = 0; xpos < 256; xpos++)
			{	
				if(mode_max[xpos] > max_mode_max)
				{
					max_mode_max = mode_max[xpos];
					mode_m[numb] = xpos;
				} 

				if(mode_max_pos[xpos] > max_mode_max_pos)
				{
					max_mode_max_pos = mode_max_pos[xpos];
					mode_p[numb] = xpos;
				} 

				mode_max[xpos] = 0;
				mode_max_pos[xpos] = 0;
			}
			numb++;
		}
	}
}

/*
max_mode_m = 0;
for(x = 0; x < numb; x++)
{
	if(mode_m[x] > max_mode_m)
	{
		max_mode_m = mode_m[x];
	}
}
*/

for(x = 0; x < XSIZE; x++)
{
	for(y = 0; y < YSIZE; y++)
	{
		if(screen.scr[x][y].complete_edge == 100)
		{
			screen.scr[x][y].complete_edge = 0;
		}
	}
}
winset(measure_win);
/*
dump_image(two_dump);
*/
for(x = 0; x < numb; x++)
{
	max_pos_in_deg[x] = (float)((float)mode_p[x] * 0.9);
	if(max_pos_in_deg[x] <= 45.0)
	{
		c_trend[x] = max_pos_in_deg[x] + 135.0;
	}

	else
	{
		c_trend[x] = max_pos_in_deg[x] - 45.0; 
	}
	
	c_plunge[x] = 0.5*acos(2.0*(float)((float)mode_m[x]/(float)max_caxis) - 1.0);
	
	if(tosave == 2)
		fprintf(grain_file,"\n%3.2f\t%3.2f",c_trend[x],c_plunge[x]*180.0/pi);

	if(c_plunge[x] < 0.0)
	{
		c_plunge[x] = 0.0;
	}

	if(c_plunge[x] > pi/2.0)
	{
		c_plunge[x] = pi/2.0;
	}

	c_plunge[x] = (pi/2.0 - c_plunge[x]);		
	c_plunge[x] = sqrt(1 - (cos(c_plunge[x])));
	
	c_trend[x] = c_trend[x] * pi / 180.0;

	fit_lines(0, 255, 255, x_cent[x] + orig_x[x], y_cent[x] + orig_y[x], 
 		 (90.0 + (c_trend[x] * 180.0 / pi)), (40.0 * ( ((c_plunge[x] * 180.0 / pi) 
									/ 90.0)) ), 0.0, pi);

	x_schmidt[x] = c_plunge[x] * (sin(c_trend[x]));
	y_schmidt[x] = c_plunge[x] * (cos(c_trend[x]));
}

winset(c_axis_win);
if(!is_normalized)
{
	color(6);/*lightblue*/ 
	for(x = 0; x <= numb; x++)
	{
		circ(x_schmidt[x], y_schmidt[x], 0.02); 
		circ(-x_schmidt[x], -y_schmidt[x], 0.02); 
	}
} 

else
{
	color(YELLOW);
	num_pix = 0;

	for(x = 0; x <= numb; x++)
	{
		if(m_grain[x] > num_pix)
		{
			num_pix = m_grain[x];
		}
	}		

	if(num_pix > 0)
	{	
		for(x = 0; x < numb; x++)
		{
			linewidth((short)(((float)(m_grain[x]) / (float)(num_pix)) * 7.0));
			circ(x_schmidt[x], y_schmidt[x], ((float)(m_grain[x]) / 
							(float)(num_pix)) * 0.12); 
			circ(-x_schmidt[x], -y_schmidt[x], ((float)(m_grain[x]) / 
							(float)(num_pix)) * 0.12); 
		}
	}
}
linewidth(1);
gflush();

if(tosave == 2)
	fclose(grain_file);
}

/********************************************************************/
/*Recursively fills a bounded region.			 	    */
/********************************************************************/
void c_axis_fill(short x, short y, short xo, short yo, long *mode_max, 
			long *mode_max_pos, char new, char boundary)
{
char check;

check = screen.scr[x][y].complete_edge;
if( (check != boundary)	 
&&(check != new) )
{
	screen.scr[x][y].complete_edge = 100;
	num_pix += 1;
	sum_x += (x - xo);
	sum_y += (y - yo);
	mode_max[screen.scr[x][y].max[SR]]++;		
	mode_max_pos[screen.scr[x][y].max_pos[SR]]++;		
	c_axis_fill(x - 1, y, xo, yo, mode_max, mode_max_pos, 100, 255);
	c_axis_fill(x, y - 1, xo, yo, mode_max, mode_max_pos, 100, 255);
	c_axis_fill(x, y + 1, xo, yo, mode_max, mode_max_pos, 100, 255);
	c_axis_fill(x + 1, y, xo, yo, mode_max, mode_max_pos, 100, 255);
}
}

/********************************************************************/
/*displays different images.					    */
/********************************************************************/
void m_display_different_images_proc(FL_OBJECT *n, long m)
{
short x, y;

if(m == 0)
{
	for(x = 0; x < XSIZE; x++)
	{
		for(y = 0; y < YSIZE; y++)
		{
			assval(two_dump, x, y, R, screen.scr[x][y].complete_edge);
			assval(two_dump, x, y, G, screen.scr[x][y].complete_edge);
			assval(two_dump, x, y, B, screen.scr[x][y].complete_edge);
		}
	}
}

else if(m == 1)
{
	for(x = 0; x < XSIZE; x++)
	{
		for(y = 0; y < YSIZE; y++)
		{
			assval(two_dump, x, y, R, screen.scr[x][y].max[SR]);
			assval(two_dump, x, y, G, screen.scr[x][y].max[SG]);
			assval(two_dump, x, y, B, screen.scr[x][y].max[SB]);
		}
	}
}

else
{
	for(x = 0; x < XSIZE; x++)
	{
		for(y = 0; y < YSIZE; y++)
		{
			assval(two_dump, x, y, R, screen.scr[x][y].max_pos[SR]);
			assval(two_dump, x, y, G, screen.scr[x][y].max_pos[SG]);
			assval(two_dump, x, y, B, screen.scr[x][y].max_pos[SB]);
		}
	}
}

dump_image(two_dump);

if(c_axis_flag == 1)
{
	quartz_c_axis_proc(NULL, 0);
}
}

/********************************************************************/
/*saves overlay image as rgb file.				    */
/********************************************************************/
void save_overlay_rgb_proc(FL_OBJECT *n, long m)
{
char *fname;
char three_dump[XSIZE][YSIZE][4];

fname = fl_show_file_selector("File To Save","","*.rgb","");
sleep(1);
measure_refresh_proc(NULL, 0);

if(fname != NULL)
{
	winset(measure_win);
	lrectread(0, 0, screen.xsize-1, screen.ysize-1, (unsigned long *)three_dump);
	save_rgb_image(fname, (char *)three_dump, XSIZE, YSIZE);
}
}

/********************************************************************/
/*Closes measurement group.					    */
/********************************************************************/
void measure_done_proc(FL_OBJECT *n, long m)
{
fl_hide_object(measure_grp);
fl_show_object(main_grp);
winclose(measure_win);
measure_win = -1;
winclose(c_axis_win);
c_axis_win = -1;
c_axis_flag = 0;
inertia_flag = 0;
}					
